var Command = require('jasmine/lib/command.js');
var Jasmine = require('jasmine/lib/jasmine.js');

require('babel/register');

module.exports = function (cwd, args) {
  var cb = arguments[arguments.length - 1];

  if ('string' !== typeof cwd) {
    cwd = process.cwd();
  }

  if (!Array.isArray(args)) {
    args = [];
  }

  var jasmine = new Jasmine({ projectBaseDir: cwd });

  if ('function' === typeof cb) {
    jasmine.addReporter(new CallbackReporter(cb));
  }

  return new Command(cwd).run(jasmine, args);
};

function CallbackReporter(cb) {
  this.__cb = cb;
  this.__hasFailed = false;
}

CallbackReporter.prototype.specDone = function (result) {
  if (result.status === 'failed') {
    this.__hasFailed = true;
  }
};

CallbackReporter.prototype.jasmineDone = function () {
  this.__cb(this.__hasFailed ? new Error() : undefined);
};
